#include <iostream>
#include "matrix.h"
using namespace std;

Matrix::Matrix(int a)
{
        createdFM=false;
        createdPI=false;
        vertex=a;
        exp = 0;
        guiOption=100;

        pMatr = new int* [vertex];
        for(int i=0; i<vertex; i++)
                {
                        *(pMatr+i)= new int [vertex];
                }
        //initialisierung
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                        {
                                pMatr[c][r]=0;
                        }
        }

        pMatr_2 = new int* [vertex];
        for(int i=0; i<vertex; i++)
                {
                        *(pMatr_2+i)= new int [vertex];
                }
        //initialisierung
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                        {
                                pMatr_2[c][r]=0;
                        }
        }
}

Matrix::~Matrix()
{
        for(int i=0; i<vertex; i++)
        {
                delete []pMatr[i];
        }
        delete []pMatr;

        for(int i=0; i<vertex; i++)
        {
                delete []pMatr_2[i];
        }
        delete []pMatr_2;

        if (createdFM==true) //zum lschen des Array von Floay-Marshall, falls benutzt
        {
                for(int i=0; i<vertex; i++)
                {
                        delete []pMatr_fm[i];
                }
                delete []pMatr_fm;

        }
        if (createdPI==true)
        {
                for(int i=0; i<vertex; i++)
                {
                        delete []pMatr_PI[i];
                }
                delete []pMatr_PI;
        }
}

void Matrix::gui()
{
        inputDistance();
        do
        {
                cout << endl;
                for (int i=1;i<15;i++)
                {
                        cout << "#";
                }
                cout << " OPTIONEN ";
                for (int i=1;i<15;i++)
                {
                        cout << "#";
                }
                cout << "\n1: Anzeigen der Graphen W und D=W^" << exp << endl;
                cout << "2: Neue Distanzen fr W eingeben" << endl;
                cout << "3: Neuen Exponent fr W eingeben" << endl;
                cout << "4: Vorgngermatrix PI aus D und W berechnen" << endl;
                cout << "5: Floyd-Warshall-Algorithmus anwenden" << endl;
                cout << "6: Ausgabe von D[0] und D[" << vertex << "] nach Floyd-Marshall" << endl;
                cout << "0: Ende" << endl;
                cin >> guiOption;

                guiSelection();

        }
        while(guiOption!=0);
}

void Matrix::inputDistance()
{
        //Distanzeingabe
	cout << "Bitte Kantengewichte eingeben (INFINITY=" << INFINITY << ")" << endl;
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                {
                        if (r==c) //Hauptdiagonale = 0
                        {
                                cout << "W(" << c+1 << "," << r+1 << ") = 0" << endl;
                        }
                        else
                        {
                                cout << "W(" << c+1 << "," << r+1 << ") : ";
                                cin >> pMatr[c][r];
                        }
                }
        }
        getMatr_W();
}


void Matrix::getMatr_W()
{
        int tmp = 0;
        int minPos = 0;

        do
        {
                cout << "Wie oft soll W mit sich multipliziert werden? ";
                cin >> exp; cout << endl;
        }
        while(exp<=0);

        //erzeugen eines tmp-Arrays

        int** tmpMatr = new int* [vertex];
        for(int i=0; i<vertex; i++)
                {
                        *(tmpMatr+i)= new int [vertex];
                }
        //uebergabe werte von D an W
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                        {
                        pMatr_2[c][r]=pMatr[c][r];
                        }
        }


        for(int l=0; l<exp; l++) //l-mal alle Kanten
        {
                //uebergabe werte von neuem W
                for (int c=0;c<vertex;c++) //c = cols = reihen
                {
                        for (int r=0;r<vertex;r++)
                                {
                                tmpMatr[c][r]=pMatr_2[c][r];
                                }
                }
                for (int i=0;i<vertex;i++) //i = reihen
                {
                        for (int j=0;j<vertex;j++) //j=  zeilen
                        {
                                if(i!=j)
                                {
                                        minPos=tmpMatr[i][j]; //gewicht an stelle matrix merken
                                        //mininum finden
                                        for (int k=0; k<vertex; k++)
                                        {
                                                tmp=(pMatr[i][k])+(tmpMatr[k][j]);
                                                //vergleichen
                                                if (tmp<minPos)
                                                {
                                                        minPos=tmp;
                                                }
                                        }
                                        pMatr_2[i][j]=minPos;
                                }
                        }
                }
        }

        //uebergabe werte von tmpMatr nach W
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                        {
                        pMatr_2[c][r]=tmpMatr[c][r];
                        }
        }

        //lschen vonn tmpMatr_2
        for(int i=0; i<vertex; i++)
        {
                delete []tmpMatr[i];
        }
        delete []tmpMatr;
}

void Matrix::guiSelection()
{
        switch(guiOption)
        {
                case(1):
                {
                        showMatr();
                }
                break;
                case(2):
                {
                        inputDistance();
                }
                break;
                case(3):
                {
                        getMatr_W();
                }
                break;
                case(4):
                {
                        PI();
                }
                break;
                case(5):
                {
                        floyd_marshall();
                }
                break;
                case(6):
                {
                        show_floyd_marshall();
                }
                break;
                case(0):
                {
                        //bergeht dadurch default ausgabe bei guiOptions==0
                }
                break;
                default:
                {
                        cout << "Ungueltige Eingabe" << endl;
                }
        }
}

void Matrix::showMatr()
{
        cout << "\nD lautet: " << endl;
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                cout << "|";
                for (int r=0;r<vertex;r++)
                {
                        cout  << pMatr[c][r];
                        if (r!=(vertex-1))
                                {
                                        cout << "\t";
                                }
                }
                cout << "|" << endl;
        }

        cout << "\nW exp " << exp << " lautet: " << endl;
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                cout << "|";
                for (int r=0;r<vertex;r++)
                {
                        cout  << pMatr_2[c][r];
                        if (r!=(vertex-1))
                                        {
                                                cout << "\t";
                                        }
                }
                cout << "|" << endl;
        }
}

void Matrix::floyd_marshall()
{
        createdFM=true;
        int tmp, minPos=0;

        pMatr_fm = new int* [vertex];
        for(int i=0; i<vertex; i++)
                {
                        *(pMatr_fm+i)= new int [vertex];
                }
        //initialisierung
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                        {
                                pMatr_fm[c][r]=pMatr[c][r];
                        }
        }

        //Die Matrix tmpMatr wird um 1 Stelle groesser erstellt, da ich immer stackfehler bekam
        int** tmpMatr = new int* [vertex+1];
        for(int i=0; i<vertex+1; i++)
                {
                        *(tmpMatr+i)= new int [vertex+1];
                }


        for(int k=0; k<vertex+1; k++) //k-mal alle knoten
        {
                //uebergabe werte von neuem W
                for (int c=0;c<vertex;c++)
                {
                        for (int r=0;r<vertex;r++)
                                {
                                tmpMatr[c][r]=pMatr_fm[c][r];
                                }
                }

                for (int i=0;i<vertex;i++) //i = reihen
                {
                        for (int j=0;j<vertex;j++) //j=  zeilen
                        {
                                if(i!=j)
                                {
                                        minPos=tmpMatr[i][j]; //gewicht an stelle matrix merken
                                        //mininum finden
                                        for (int u=0; u<vertex; u++)
                                        {
                                                tmp=(pMatr_fm[i][k])+(tmpMatr[k][j]);
                                                //vergleichen
                                                if (tmp<minPos)
                                                {
                                                        minPos=tmp;
                                                }
                                        }
                                        pMatr_fm[i][j]=minPos;
                                }
                        }
                }
        }

        //uebergabe werte von tmpMatr nach D[vertex]
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                        {
                        pMatr_fm[c][r]=tmpMatr[c][r];
                        }
        }

        //lschen vonn tmpMatr
        for(int i=0; i<vertex; i++)
        {
                delete []tmpMatr[i];
        }
        delete []tmpMatr;
}

void Matrix::show_floyd_marshall()
{
        cout << "\nD[0] lautet: " << endl;
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                cout << "|";
                for (int r=0;r<vertex;r++)
                {
                        cout  << pMatr[c][r];
                        if (r!=(vertex-1))
                                {
                                        cout << "\t";
                                }
                }
                cout << "|" << endl;
        }

        cout << "\nD[" << vertex << "] lautet: " << endl;
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                cout << "|";
                for (int r=0;r<vertex;r++)
                {
                        cout  << pMatr_fm[c][r];
                        if (r!=(vertex-1))
                                        {
                                                cout << "\t";
                                        }
                }
                cout << "|" << endl;
        }

}

void Matrix::PI()
{
        createdPI=true;

        pMatr_PI = new int* [vertex];
        for(int i=0; i<vertex; i++)
                {
                        *(pMatr_PI+i)= new int [vertex];
                }
        //initialisierung
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                for (int r=0;r<vertex;r++)
                        {
                                pMatr_PI[c][r]=0;
                        }
        }

        int result,tmp=0; //das abzufragende ergebniss

        for (int i=0; i<vertex; i++)
        {
                for (int j=0; j<vertex; j++)
                {
                        if (i!=j)
                        {
                                result = pMatr_2[i][j];
                                for (int k=0; k<vertex; k++)
                                {
                                        tmp=pMatr_2[i][k]+pMatr[k][j];
                                        if (k!=j)
                                        {
                                                if (tmp==result)
                                                {
                                                        pMatr_PI[i][j]=k+1;
                                                        //k=(vertex-1); //schleifenabbruch
                                                }
                                        }
                                }
                        }
                }
        }
        showPI();
}

void Matrix::showPI()
{
        cout << "\nPI lautet: " << endl;
        for (int c=0;c<vertex;c++) //c = cols = reihen
        {
                cout << "|";
                for (int r=0;r<vertex;r++)
                {
                        cout  << pMatr_PI[c][r];
                        if (r!=(vertex-1))
                                {
                                        cout << "\t";
                                }
                }
                cout << "|" << endl;
        }
}
